<template>
  <div id="main-app">
    <div class="common-layout">
      <header>
        <Menu />
        <div v-if="user?.email" id="profile-card-wrapper">
          <ProfileCard :email="user.email" />
        </div>
      </header>
      <main>
        <router-view />
        <el-dialog v-model="dialogSubmitVisible" title="Login as a user" width="80%" draggable>
          <h3 v-if="redirect">
            You must be logged in if you want to talk to others.
          </h3>
          <el-form :model="form" label-width="120px">
            <el-form-item label="Login">
              <el-input v-model="form.login" />
            </el-form-item>
            <el-form-item label="Password">
              <el-input v-model="form.password" type="password" show-password />
            </el-form-item>
          </el-form>
          <template #footer>
            <span class="dialog-footer">
              <el-button type="primary" @click="handleLogin">Login</el-button>
              <el-button @click="dialogSubmitVisible = false">Cancel</el-button>
            </span>
          </template>
        </el-dialog>
      </main>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref, Ref, reactive, onMounted, getCurrentInstance } from 'vue';
import axios, { AxiosResponse } from 'axios';

import { ElNotification } from 'element-plus';
import useEmitter from './composables/useEmitter';
import { useRouter } from 'vue-router';

import { useStore } from './stores';
import { storeToRefs } from 'pinia';

import Menu from './components/Menu.vue';
import ProfileCard from './components/ProfileCard.vue';


const store = useStore();
const { user } = storeToRefs(store);
const router = useRouter();
const emitter = useEmitter();

interface User {
  email: string;
  isAdmin: boolean;
  isLogged: boolean;
  uuid: string;
  admin: boolean;
  logged: boolean;
}

const dialogSubmitVisible: Ref<boolean> = ref(false);
const form = reactive({
  login: '',
  password: '',
});

const redirect: Ref<boolean | string> = ref(false);
emitter.on('login', () => {
  dialogSubmitVisible.value = true;
});

emitter.on('login-before-talk', (data) => {
  dialogSubmitVisible.value = true;
  redirect.value = data.author;
});

emitter.on('logout', handleLogout);

onMounted(()=>{
  window.addEventListener('beforeunload', (event)=>{
    if(store.user) {
      localStorage.setItem('user',JSON.stringify(store.user));
      store.disconnect();
    }

} );

  window.addEventListener('DOMContentLoaded',(event)=>{

    if(localStorage.getItem('user')){
      const reloadedUser = (JSON.parse(localStorage.getItem('user')));
      store.setUser(reloadedUser);
      store.connect();
  }
  
  });
})


function handleLogout() {
  
  axios
  // @ts-ignore  
    .post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/user/logout`, {
      uuid: user.value.uuid,
    })
    .then(({ data }) => {
      dialogSubmitVisible.value = false;
      openLoggedOut();
      store.wanishUser();
      store.disconnect();
      localStorage.setItem('user', null);
      router.push('/');
      //window.location.reload();
    })
    .catch((err) => {
      console.error(err);
    });
}

const handleLogin = () => {
  dialogSubmitVisible.value = false;
  
  axios
    // @ts-ignore
    .post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/user/login`, {
      email: form.login,
      password: form.password,
    })
    .then((response: AxiosResponse<User>) => {
      if (response.status === 200) {
        openLogged();
        store.setUser({
          email: form.login,
          isAdmin: response.data.isAdmin,
          uuid: response.data.uuid,
        });
        store.connect();
        if (redirect.value) {
          router.push('/communicator/' + redirect.value);
        }
        getCurrentInstance()?.proxy?.$forceUpdate();
      }
      window.location.reload();
    })
    .catch((err) => {
      console.error(err);
      openNonLogged();
    });
};

const openLogged = () => {
  ElNotification({
    title: 'Success',
    message: 'You have been logged in',
    type: 'success',
    position: 'bottom-right',
  });
};

const openNonLogged = () => {
  ElNotification({
    title: 'Error',
    message: 'Wrong credentials',
    type: 'error',
    position: 'bottom-right',
  });
};

const openLoggedOut = () => {
  ElNotification({
    title: 'Success',
    message: 'You have been logged out',
    type: 'success',
    position: 'bottom-right',
  });
};
</script>

<style scoped lang="scss">
#main-app {
  display: flex;
  flex-direction: column;
  position: absolute;
  top: 0px;
  left: 0px;
  padding: 5%;

  #profile-card-wrapper {
    float: right;
    position: absolute;
    top: 12px;
    right: 36px;
  }
}

header {
  line-height: 1.5;
}

main {
  width: 80vw;
  position: relative;
}
</style>
